SystemOrganization addCategory: #'OB-TreeView'!

!OBColumn methodsFor: '*ob-treeview-navigation' stamp: 'jk 4/2/2008 15:28'!
addSubtreeWithFan: anOBFan selection: aSmallInteger 
	self listHolder 
		at: aSmallInteger
		putFan: anOBFan! !

!OBList methodsFor: '*ob-treeview-nodes' stamp: 'jk 4/6/2008 17:56'!
at: anInteger putFan: anOBFan 
	self treeHolder
		at: self treeSelection
		putFan: anOBFan.
	self extendTreeSelection: anInteger.
! !

!OBList methodsFor: '*ob-treeview-selecting' stamp: 'jk 4/6/2008 17:41'!
extendTreeSelection: anInteger 
	self treePosition extendSelection: anInteger! !

!OBList methodsFor: '*ob-treeview-selecting' stamp: 'jk 4/7/2008 12:38'!
treeHolder
	^ (fan class = OBTreeHolder)
		ifTrue: [ fan ]
		ifFalse: [ fan := fan asTree ]! !

!OBList methodsFor: '*ob-treeview-refactory-selecting' stamp: 'jk 4/7/2008 12:37'!
treePosition
	^ (position class = OBTreePosition)
		ifTrue: [ position ]
		ifFalse: [ position := position asTreePosition ]! !

!OBList methodsFor: '*ob-treeview-selecting' stamp: 'jk 4/6/2008 17:38'!
treeSelection
	^ self treePosition treeSelection! !

!OBList methodsFor: '*ob-treeview-selecting' stamp: 'jk 4/3/2008 18:00'!
treeSelection: anArray 
	self treeSelection selection: anArray! !

Object subclass: #OBTreeEdgeNavigation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TreeView'!

!OBTreeEdgeNavigation methodsFor: 'comparing' stamp: 'jk 4/2/2008 12:58'!
= anObject 
	^ self class = anObject class! !

!OBTreeEdgeNavigation methodsFor: 'navigation' stamp: 'jk 4/2/2008 14:33'!
columnAfter: anOBColumn withFan: anOBFan selection: aSmallInteger 
	anOBColumn addSubtreeWithFan: anOBFan selection: aSmallInteger.
	^ anOBColumn! !

!OBTreeEdgeNavigation methodsFor: 'testing' stamp: 'jk 4/2/2008 14:17'!
isDefaultNavigation
	^ false! !

Object subclass: #OBTreeHolder
	instanceVariableNames: 'fan subfans'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TreeView'!

!OBTreeHolder class methodsFor: 'instance creation' stamp: 'jk 4/2/2008 14:51'!
fan: anOBFan 
	^ self new fan: anOBFan! !

!OBTreeHolder methodsFor: 'accessing' stamp: 'jk 4/2/2008 15:28'!
at: anArray putFan: anOBFan 
	self 
		atSubtree: anArray
		putTree: anOBFan asTree! !

!OBTreeHolder methodsFor: 'accessing' stamp: 'jk 4/2/2008 15:31'!
atList: aSmallInteger putTree: anOBTreeHolder 
	^ self subfans at: aSmallInteger put: anOBTreeHolder! !

!OBTreeHolder methodsFor: 'accessing' stamp: 'jk 4/2/2008 15:29'!
atSubtree: anArray putTree: anOBTreeHolder 
	^ anArray size > 1 
		ifTrue: 
			[ (self subfans at: anArray first) 
				atSubtree: anArray allButFirst
				putTree: anOBTreeHolder ]
		ifFalse: 
			[ self 
				atList: anArray first
				putTree: anOBTreeHolder ]! !

!OBTreeHolder methodsFor: 'accessing' stamp: 'jk 4/6/2008 17:58'!
children
	^ self fan children! !

!OBTreeHolder methodsFor: 'accessing' stamp: 'jk 4/7/2008 10:29'!
childrenAt: index
	^ (self fanAt: index) children! !

!OBTreeHolder methodsFor: 'accessing' stamp: 'jk 4/6/2008 17:53'!
fan
	^ fan! !

!OBTreeHolder methodsFor: 'initializing' stamp: 'jk 4/2/2008 14:55'!
fan: anOBFan 
	fan := anOBFan! !

!OBTreeHolder methodsFor: 'accessing' stamp: 'jk 4/6/2008 18:41'!
fanAt: anArray 
	^ anArray size > 1 
		ifTrue: [(self treeHolderAt: anArray first) fanAt: anArray allButFirst]
		ifFalse: [self fan]! !

!OBTreeHolder methodsFor: 'testing' stamp: 'jk 4/6/2008 17:44'!
isEmpty
	^ self fan isEmpty! !

!OBTreeHolder methodsFor: 'accessing' stamp: 'jk 4/6/2008 18:39'!
nodeAt: anArray 
	^ (self fanAt: anArray) nodeAt: anArray last! !

!OBTreeHolder methodsFor: 'accessing' stamp: 'jk 4/6/2008 17:57'!
parent
	^ fan parent! !

!OBTreeHolder methodsFor: 'accessing' stamp: 'jk 4/7/2008 10:26'!
parentAt: index
	^ (self fanAt: index) parent! !

!OBTreeHolder methodsFor: 'accessing' stamp: 'jk 4/2/2008 15:32'!
subfans
	^ subfans ifNil: [ subfans := Dictionary new ]! !

!OBTreeHolder methodsFor: 'accessing' stamp: 'jk 4/6/2008 18:42'!
treeHolderAt: aSmallInteger 
	^ self subfans at: aSmallInteger! !

!Object methodsFor: '*ob-treeview-converting' stamp: 'jk 4/2/2008 14:45'!
asArray
	^ Array with: self! !

!OBMetaEdge methodsFor: '*ob-treeview-navigation' stamp: 'jk 4/2/2008 12:20'!
navigateTree
	self navigation: OBTreeEdgeNavigation new! !

!OBPosition methodsFor: '*ob-treeview-converting' stamp: 'jk 4/4/2008 10:43'!
asTreePosition
	^ OBTreePosition index: self index! !

OBPosition subclass: #OBTreePosition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TreeView'!

!OBTreePosition class methodsFor: 'instance creation' stamp: 'jk 4/4/2008 10:47'!
index: aSmallInteger 
	^ self new index: aSmallInteger asArray! !

!OBTreePosition methodsFor: 'converting' stamp: 'jk 4/7/2008 12:41'!
asPosition
	^ OBPosition new selection: self index first! !

!OBTreePosition methodsFor: 'as yet unclassified' stamp: 'jk 4/3/2008 18:05'!
clearSelection
	self index: #(0)! !

!OBTreePosition methodsFor: 'accessing' stamp: 'jk 4/4/2008 11:21'!
extendSelection: aSmallInteger 
	aSmallInteger = 0 ifFalse:
		[ self index: (self index copyWith: aSmallInteger) ]! !

!OBTreePosition methodsFor: 'as yet unclassified' stamp: 'jk 4/3/2008 18:06'!
hasSelection
	^ self index first > 0! !

!OBTreePosition methodsFor: 'as yet unclassified' stamp: 'jk 4/3/2008 18:05'!
selection
	^ self index last! !

!OBTreePosition methodsFor: 'selecting' stamp: 'jk 4/6/2008 17:40'!
treeSelection
	^ self index! !

!OBFan methodsFor: '*ob-treeview-converting' stamp: 'jk 4/2/2008 14:46'!
asTree
	^ OBTreeHolder fan: self! !
